## org.apache.commons.math.linear
Interface FieldDecompositionSolver<T extends FieldElement<T>>

Type Parameters:
  `T` - the type of the field elements

All Known Implementing Classes:
  FieldLUDecompositionImpl.Solver

    public interface FieldDecompositionSolver<T extends FieldElement<T>>

Interface handling decomposition algorithms that can solve A × X = B.

Decomposition algorithms decompose an A matrix has a product of several specific matrices from which they can solve A × X = B in least squares sense: they find X such that ||A × X - B|| is minimal.

Some solvers like `LUDecomposition` can only find the solution for square matrices and when the solution is an exact linear solution, i.e. when ||A × X - B|| is exactly 0. Other solvers can also find solutions with non-square matrix A and with non-null minimal norm. If an exact linear solution exists it is also the minimal norm solution.

Since:
  2.0
Version:
  $Revision: 781122 $ $Date: 2009-06-02 14:53:23 -0400 (Tue, 02 Jun 2009) $

Method Summary
`FieldMatrix<T>` `getInverse()` Get the inverse (or pseudo-inverse) of the decomposed matrix.
`boolean` `isNonSingular()` Check if the decomposed matrix is non-singular.
`FieldMatrix<T>` `solve(FieldMatrix<T> b)` Solve the linear equation A × X = B for matrices A.
`FieldVector<T>` `solve(FieldVector<T> b)` Solve the linear equation A × X = B for matrices A.
`T[]` `solve(T[] b)` Solve the linear equation A × X = B for matrices A.

Method Detail

### solve

    T[] solve(T[] b)
                                      throws java.lang.IllegalArgumentException,
                                             InvalidMatrixException

  Solve the linear equation A × X = B for matrices A.

  The A matrix is implicit, it is provided by the underlying decomposition algorithm.

  Parameters:
    `b` - right-hand side of the equation A × X = B
  Returns:
    a vector X that minimizes the two norm of A × X - B
  Throws:
    `java.lang.IllegalArgumentException` - if matrices dimensions don't match
    `InvalidMatrixException` - if decomposed matrix is singular

### solve

    FieldVector<T> solve(FieldVector<T> b)
                                                 throws java.lang.IllegalArgumentException,
                                                        InvalidMatrixException

  Solve the linear equation A × X = B for matrices A.

  The A matrix is implicit, it is provided by the underlying decomposition algorithm.

  Parameters:
    `b` - right-hand side of the equation A × X = B
  Returns:
    a vector X that minimizes the two norm of A × X - B
  Throws:
    `java.lang.IllegalArgumentException` - if matrices dimensions don't match
    `InvalidMatrixException` - if decomposed matrix is singular

### solve

    FieldMatrix<T> solve(FieldMatrix<T> b)
                                                 throws java.lang.IllegalArgumentException,
                                                        InvalidMatrixException

  Solve the linear equation A × X = B for matrices A.

  The A matrix is implicit, it is provided by the underlying decomposition algorithm.

  Parameters:
    `b` - right-hand side of the equation A × X = B
  Returns:
    a matrix X that minimizes the two norm of A × X - B
  Throws:
    `java.lang.IllegalArgumentException` - if matrices dimensions don't match
    `InvalidMatrixException` - if decomposed matrix is singular

### isNonSingular

    boolean isNonSingular()

  Check if the decomposed matrix is non-singular.

  Returns:
    true if the decomposed matrix is non-singular

### getInverse

    FieldMatrix<T> getInverse()
                                                      throws InvalidMatrixException

  Get the inverse (or pseudo-inverse) of the decomposed matrix.

  Returns:
    inverse matrix
  Throws:
    `InvalidMatrixException` - if decomposed matrix is singular

Copyright (c) 2003-2011 Apache Software Foundation